package com.its.api.its.service.vds;

import com.its.api.its.model.dto.vds.TbVdsDtctLinkRltnDto;
import com.its.api.its.model.entity.vds.TbVdsDtctLinkRltn;
import com.its.api.its.model.entity.vds.TbVdsDtctLinkRltnKey;
import com.its.api.its.repository.vds.TbVdsDtctLinkRltnRepository;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbVdsDtctLinkRltnService {

    private final TbVdsDtctLinkRltnRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbVdsDtctLinkRltn requireOne(TbVdsDtctLinkRltnKey id) {
        return this.repo.findById(id.getDtctNmbr())
                .orElseThrow(() -> new NoSuchElementException("데이터가 존재하지 않습니다: " + id));
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbVdsDtctLinkRltnDto> findAll() {
        List<TbVdsDtctLinkRltnDto> result = new ArrayList<>();
        List<TbVdsDtctLinkRltn> data = this.repo.findAll();
        for (TbVdsDtctLinkRltn entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbVdsDtctLinkRltnDto findById(TbVdsDtctLinkRltnKey id) {
        TbVdsDtctLinkRltn entity = requireOne(id);
        return entity.toDto();
    }

    // 데이터 변경
    @Transactional
    public TbVdsDtctLinkRltnDto updateById(TbVdsDtctLinkRltnKey id, TbVdsDtctLinkRltnDto.TbVdsDtctLinkRltnUpdReq req) {
        TbVdsDtctLinkRltn entity = requireOne(id);
        entity.updateInfo(req);
        this.repo.save(entity);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-목록(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public List<TbVdsDtctLinkRltnDto> mergeInfoList(List<TbVdsDtctLinkRltnDto.TbVdsDtctLinkRltnUpdReq> reqList) {
        List<TbVdsDtctLinkRltnDto> result = new ArrayList<>();
        for (TbVdsDtctLinkRltnDto.TbVdsDtctLinkRltnUpdReq req : reqList) {
            TbVdsDtctLinkRltn obj = req.toEntity();
            this.repo.save(obj);
            result.add(obj.toDto());
        }
        return result;
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbVdsDtctLinkRltnDto mergeInfo(TbVdsDtctLinkRltnDto.TbVdsDtctLinkRltnUpdReq req) {
        TbVdsDtctLinkRltn obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    @Transactional
    public TbVdsDtctLinkRltnDto deleteById(TbVdsDtctLinkRltnKey id) {
        TbVdsDtctLinkRltn entity = requireOne(id);
        this.repo.deleteById(id.getDtctNmbr());
        return entity.toDto();
    }

    // 정보 삭제-목록, 존재하는 데이터 만 삭제
    @Transactional
    public List<TbVdsDtctLinkRltnDto> deleteByIds(List<TbVdsDtctLinkRltnKey> ids) {
        List<TbVdsDtctLinkRltnDto> result = new ArrayList<>();
        for (TbVdsDtctLinkRltnKey id : ids) {
            Optional<TbVdsDtctLinkRltn> obj = this.repo.findById(id.getDtctNmbr());
            if (obj.isPresent()) {
                this.repo.deleteById(id.getDtctNmbr());
                result.add(obj.get().toDto());
            }
        }
        return result;
    }

}
